-- si teniu dubtes sobre el que fa alguna de les operacions que no es
-- donen, proveules a ghci

--aplica una funció a tots els elements d'una llista.
map :: (a->b) -> [a] -> [b]
map f []     = []
map f (x:xs) = f x : map f xs

{- opera els elements d'una llista de dreta a esquerra amb una funció
   donada i un element neutre donat -}
foldr :: (a -> b -> b) -> b -> [a] -> b
foldr f z []     = z
foldr f z (x:xs) = f x (foldr f z xs)


{- opera els elements d'una llista d'esquerra a dreta amb una funció
   donada i un element neutre donat -}
foldl :: (a -> b -> a) -> a -> [b] -> a
foldl f z []     = z
foldl f z (x:xs) = foldl f (f z x) xs


{- donada una funció f i un valor n, crea una llista infinita on el 
   primer element és n i la resta d'elements s'on igual al resultat 
   d'aplicar f a l'anterior element: [n, (f n), (f (f n)),....] -}
iterate :: (a -> a) -> a -> [a]


-- indica si tots els element d'una llista satisfan una propietat donada
all :: (a -> Bool) -> [a] -> Bool


-- indica si algun  dels element d'una llista satisfa una propietat donada
any  :: (a -> Bool) -> [a] -> Bool


-- filtra els elements d'una llista segons una propietat donada
filter :: (a -> Bool) -> [a] -> [a]


-- retorna el prefix més llarg d'una llista que satisfà una propietat donada
takeWhile :: (a -> Bool) -> [a] -> [a]


{- retorna la lista resultant d'eliminar el prefix més llarg que satisfà una 
   propietat donada -}
dropWhile :: (a -> Bool) -> [a] -> [a]


-- donades dues llistes genera una llista de parells
zip :: [a] -> [b] -> [(a, b)]


{- donades una operació i dues llistes genera una llista obtinguda operant 
   els elements de les llistes dos a dos -}
zipWith :: (a -> b -> c) -> [a] -> [b] -> [c]


-- definiu el zipWith usant el zip i les generadores de llistes (com a 
-- l'exeple del quicksort)

-- mireu a ghci el tipus de (,)
-- utilitzeu aquesta operació per definit zip usant zipWith


